import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;


public class Client extends Frame
  implements ActionListener,WindowListener{      //ascoltatore di s stesso
protected TextArea log;
protected TextField iptxt,porttxt,nomefiletxt;
protected Button button;
protected DatagramSocket udp_socket;
protected ServerSocket lst_socket;
public Client()
  {
  super("Client by Luca \"Luke\" Armani");
  iptxt=new TextField(20);
  porttxt=new TextField(5);
  nomefiletxt=new TextField(50);
  button=new Button("Send Req");
  button.addActionListener(this);
  addWindowListener(this);
  log=new TextArea("",8,60,TextArea.SCROLLBARS_VERTICAL_ONLY);
  log.setEditable(false);
  setSize(500,300);
  setLayout(new java.awt.FlowLayout());
  add(iptxt);
  add(new Label("ip"));
  add(porttxt);
  add(new Label("port"));
  add(nomefiletxt);
  add(new Label("filename"));
  add(button);
  add(log);
  try{
	udp_socket=new DatagramSocket();
	lst_socket=new ServerSocket(udp_socket.getLocalPort());
  lst_socket.setSoTimeout(60000);
	}
	catch(Exception ecc) {log.append("Exception: "+ecc+"\n");}
  show();
  }
public void actionPerformed(ActionEvent ev)
  {
 	DatagramPacket packet;
	int port;
	long size;
	try{
	port=Integer.parseInt(porttxt.getText()); 
	packet=new DatagramPacket(new byte[256],256,
		     InetAddress.getByName(iptxt.getText()),port);
	packet.setData(nomefiletxt.getText().getBytes());
	udp_socket.send(packet);
	log.append("Packet sent\n");
	log.append("Waiting for response...\n");  
	Socket tcp_socket=lst_socket.accept();
	tcp_socket.setSoTimeout(60000);
	InputStream input=tcp_socket.getInputStream();
	long tot=0;
	int nread;
	byte[] buffer=new byte[512];
	while((nread=input.read(buffer))>0)
		tot+=nread;
	if(tot>0) log.append("File found, "+tot+" bytes received\n");
	else log.append("File not found\n");
	}//try
	catch(InterruptedIOException ecc) {log.append("Server not responding\n");}
	catch(Exception ecc) {log.append("Exception: "+ecc+"\n");}
  //finally{ try{tcp_socket.close();}catch(Exception ecc2){}  }
  }
public void windowOpened(WindowEvent e)
  {}
public void windowClosing(WindowEvent e)
  {dispose();
   System.exit(0);
  }
public void windowClosed(WindowEvent e)
  {}
public void windowIconified(WindowEvent e)
  {}
public void windowDeiconified(WindowEvent e)
  {}
public void windowActivated(WindowEvent e) 
  {}
public void windowDeactivated(WindowEvent e)
  {}
public static void main(String args[])
  {new Client();}
}